#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <dir.h>

extern unsigned _cdecl _stklen = 32000;

char far *original_dta  = "";
char log_name[128]      = "";
long file_counter       = 0;

char *splice(char *os,char *s1,char *s2)
{
    int i, j, ch, has_slash;

    has_slash = 0;
    for (j=0; (ch = os[j] = s1[j]); j++) {
        if (ch == '\\')
            has_slash = 1;
        else
            has_slash = 0;
    }
    if (!has_slash)
        os[j++] = '\\';
    for (i=0; (os[j++] = s2[i++]); )
        ;
    strupr(os);
    return(os);
}

int ucpos(char *searchtag,char *fulltag)
{
    int i, j, lensrch;

    if (lensrch = strlen(searchtag)) {
	j = strlen(fulltag) - lensrch + 1;
	for (i = 0; i < j; i++) {
	    if (!strnicmp(searchtag,&fulltag[i],lensrch))
		return(i);
	}
	return(-1);
    }
    return(0);
}

int is_archive(char *filename)
{
    if (ucpos(".ARJ",filename) > 0)
        return(1);
    if (ucpos(".ZIP",filename) > 0)
        return(2);
    if (ucpos(".LZH",filename) > 0)
        return(3);
    return(0);
}

void perform_archive_test(char *filename)
{
    int archive_type;
    char far *local_dta;
    char work[256];

    if (!(archive_type = is_archive(filename))) {
        fprintf(stderr,"Skipping: %s\r\n",filename);
        return;
    }
    fprintf(stderr,"  Testing file number %ld: %s\r\n",++file_counter,filename);
    local_dta = getdta();
    setdta(original_dta);
    switch (archive_type) {
        case 1:
            sprintf(work,"arj t %s >>%s",filename,log_name);
            system(work);
            goto ExitProcess;
        case 2:
            sprintf(work,"pkunzip -t %s >>%s",filename,log_name);
            system(work);
            goto ExitProcess;
        case 3:
            sprintf(work,"lharc t %s >>%s",filename,log_name);
            system(work);
            goto ExitProcess;
    }
ExitProcess:
    setdta(local_dta);
}

void process_directory(char *currdir)
{
    struct ffblk ffblk;
    int finished, attrib, i;
    char temp[82];
    char dta_buffer[512];
    char newdir[256];
    char far *local_dta;

    local_dta = getdta();
    setdta((char far *) dta_buffer);
    fprintf(stderr,"Processing directory: %s\r\n",currdir);
    attrib = 0x00FF;
    finished = findfirst("*.*",&ffblk,attrib);
    while (!finished) {
        if (ffblk.ff_name[0] != '.') {
            if (ffblk.ff_attrib & FA_DIREC) {
                splice(newdir,currdir,ffblk.ff_name);
                if (!chdir(newdir)) {
//                            fprintf(stderr,"Recursive descent: %s\r\n",newdir);
                    process_directory(newdir);
//                            fprintf(stderr,"Recursive ascent: %s\r\n",ffblk.ff_name);
                    setdta(local_dta);
                    chdir(currdir);
                    setdta((char far *) dta_buffer);
                }
                else {
                    fprintf(stderr,"ERROR: cannot change to directory '%s'\007\007\007\r\n",newdir);
                    gets(temp);
                }
            }
            else {
                perform_archive_test(ffblk.ff_name);
            }
        }
        finished = findnext(&ffblk);
    }
    setdta(local_dta);
}

void main(void)
{
    char cwd[128];

    getcwd(cwd,120);
    splice(log_name,cwd,"ARJT.LOG");
    unlink(log_name);
    original_dta = getdta();
    file_counter = 0;
    process_directory(cwd);
    setdta(original_dta);
    printf("\r\n\nFiles Tested : %ld\007\007\007\007\007\r\n\n",file_counter);
}
