/*****************************************************************************
  MODELESS.H

  Purpose:  
  	Interface for CModelessDialog, a reusable class for creating modeless
  	dialogs.

  Functions: 
  	CModelessDialog::CModelessDialog()		-- constructor
  	CModelessDialog::~CModelessDialog()		-- destructor
  	CModelessDialog::Create()				-- creates dialog window
  	CModelessDialog::OnCancel()				-- WM_COMMAND IDCANCEL handler
  	CModelessDialog::OnOK()					-- WM_COMMAND IDOK handler
  	CModelessDialog::PostNcDestroy()		-- called after WM_NCDESTROY

  Development Team:
  	Mary Kirtland

  Written by Microsoft Product Support Services, Premier ISV Support
  Copyright (c) 1994 Microsoft Corporation. All rights reserved.
\****************************************************************************/

#ifndef __MODELESS_H__
	#define __MODELESS_H__
	
class CModelessDialog : public CDialog
{
	DECLARE_DYNAMIC(CModelessDialog)

// Construction
public:
	CModelessDialog();
	BOOL Create(LPCSTR lpszTemplateName, CWnd* pParentWnd = NULL);
	BOOL Create(UINT nIDTemplate, CWnd* pParentWnd = NULL);
   
// Overridables
protected:
	virtual void OnCancel();
	virtual void OnOK();
	virtual void PostNcDestroy();
               
// Implementation
public:
	virtual ~CModelessDialog();
	
protected:
	// Generated message map functions	               
	//{{AFX_MSG(CModelessDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
}; 

#endif //__MODELESS_H__


