

// A bitmap demo program using YACL
//
// M. A. Sridhar
// April 7, 1994

#include "ui/ui.h"


// ======================== Class MyComposite ===========================

class MyComposite: public UI_CompositeVObject {

public:
    MyComposite ();
    ~MyComposite ();
    
    // Override the Composite's virtual method:
    void Initialize ();

    bool Paint ();
};

    
MyComposite::MyComposite()
: UI_CompositeVObject (NULL, NULL, FALSE, UI_Rectangle (40, 40, 400, 300))
{
}


void MyComposite::Initialize ()
{
    UI_CompositeVObject::Initialize (); // Absolutely essential!
    CreateDisplaySurface ();
    _title = "YACL Bitmap Demo";
    // Note that the title cannot be set before creating the display
    // surface, because the assignment to the title causes Paint to be
    // called.
}


char* TestMap[] = {
    "+OBM_RGARROW",
    "+OBM_LFARROW",
    "+OBM_UPARROW",
    "+OBM_DNARROW",
    "+OBM_RGARROWD",
    "+OBM_LFARROWD",
    "+OBM_UPARROWD",
    "+OBM_DNARROWD",
    "+OBM_REDUCE",
    "+OBM_ZOOM",
    "+OBM_RGARROWI",
    0
};
bool MyComposite::Paint ()
{
    if (_displaySurface) {
        for (short i = 0; TestMap[i] != 0; i++) {
            UI_BitMap bm (TestMap[i]);
            bm.DrawOn (*_displaySurface, UI_Point (10 + 30*i, 10));
        }
        UI_BitMap m;
        m.CopyFrom (*_displaySurface, UI_Rectangle (0, 0, 150, 150));
        m.DrawOn (*_displaySurface, UI_Point (10, 40));
        _displaySurface->FrameRectangle (UI_Rectangle (10, 40, 150, 150));
        return TRUE;
    }
    return FALSE;
}



MyComposite::~MyComposite ()
{
    DestroyDisplaySurface ();
}




// ========================== Main program ==========================


int UI_Application::Main (int, char* [])
{
    Controller().MakeTopWindow (new MyComposite);
    Run();
}


