

#include "ui/ui.h"
#include "ui/interval.h"
#include "appwin.h"

#define ID_MESSAGE 10


typedef CL_Binding<AppWindow> Bind;

#if defined(__GNUC__)
template class CL_Binding<AppWindow>;
#endif

AppWindow::AppWindow()
: UI_CompositeVObject (NULL, NULL, FALSE, UI_Rectangle (50, 50, 600, 300))
{
    _reading  = new UI_Label (this, UI_Rectangle (500, 10, 80, 30));
    _bar      = new UI_VScrollBar (this, UI_Rectangle (500, 50, 20, 150), 12);

    _bar->Range() = CL_Interval (0, 20); 

    Bind bind (this, (Bind::MethodPtr) &AppWindow::DoScroll);
    _bar->ClientSet().Add (bind, 1);

    _title = "YACL ColorMap Demo";
}


AppWindow::~AppWindow()
{
    DestroyDisplaySurface ();
}


void AppWindow::Initialize ()
{
    short d = 0;
    UI_CompositeVObject::Initialize(); // Very important!!
    CreateDisplaySurface ();

    UI_ColorMap &cmap = _displaySurface->Colormap ();
    //cmap.UseDefault ();

    for (short i = 1; i < 160; i+=10 )  {
        UI_Color *c = new UI_Color (i*2000, 100*i, 10000+i*4);
        d = cmap.Add (*c);
        delete c;
    }

    cmap.Install ();
}



bool AppWindow::Paint ()
{
    long c;
    c  = (UI_ColorMapHandle) ((CL_Interval*) _bar ->Model())->Low();
    UI_ColorMapHandle &index = (UI_ColorMapHandle) c;

    UI_ColorMap &cmap = _displaySurface->Colormap ();
    _displaySurface->ColorRectangle (UI_Rectangle (30, 20, 200, 200), 
                                     cmap [index]);

    _reading->Title () = "Handle: " + CL_String (c);
    return FALSE;
}


bool AppWindow::DoScroll (CL_Object&, long)
{
    return Paint ();
}


