

#include "ui/ui.h"

#include "appwin.h"

#define ID_OK            1
#define ID_CANCEL        2
#define ID_NAME          10
#define ID_SSN           11

UI_ViewDescriptor DlgDesc [] = {
{View_Label      ,         -1,  22,  18,  55, 16, FALSE,  "Name:",  NULL},
{View_Label      ,         -1,  22,  58,  55, 16, FALSE,  "SSN:",   NULL},
{View_StringEditor, ID_NAME,    92,  16, 180, 30, TRUE ,  "",       NULL},
{View_StringEditor, ID_SSN,     92,  56, 180, 30, TRUE ,  "",       NULL},
{View_PushButton ,  ID_OK,      55, 106,  80, 28, TRUE ,  "Ok",     NULL},
{View_PushButton ,  ID_CANCEL, 160, 106,  80, 28, TRUE ,  "Cancel", NULL},
{View_None, 0, 0}
}; 


UI_DialogEventDescriptor terms[] = {
    {ID_OK,     Event_Select},
    {ID_CANCEL, Event_Select},
    {0,         Event_None}
};


AppWindow::AppWindow ()
: UI_CompositeVObject (NULL, NULL, FALSE, UI_Rectangle (50, 50, 500, 400))
{
    _title = "YACL Dialog Demo";
    _btn   = new UI_PushButton (this, UI_Rectangle (30, 30, 70, 30));
    _btn->Title() = "Show";
}







bool AppWindow::HandleChildEvent(UI_Event* e)
{
    if( e->Origin() != _btn || e->Type() != Event_Select)
        return FALSE;
    UI_Dialog* dlg = new UI_Dialog (this, DlgDesc,
                                    UI_Rectangle (20, 40, 300, 150),
                                    terms);
    dlg->Font().PointSize(9);
    // Set initial value:
    CL_String& name = *(CL_String*) ((*dlg)[ID_NAME]).Model();
    name = "John Doe";

    // Execute the dialog modally:
    UI_ViewID btn_id = dlg->ExecuteModal ().id;
    CL_String user_name,  user_ssn;
    if (btn_id == ID_OK) {
        // User clicked the ok button
        user_name = *(CL_String*) ((*dlg)[ID_NAME]).Model();
        user_ssn  = *(CL_String*) ((*dlg)[ID_SSN ]).Model();
    }
    _Application->Destroy (dlg);
    return TRUE;
}

