

#include "ui/ui.h"

#include "appwin.h"


UI_ViewDescriptor desc[] = {
    {View_PushButton, 2, 0, 0,  60, 30, TRUE, "Start"},
    {View_PushButton, 3, 0, 60, 60, 30, TRUE, "Quit"},
    {View_None, -1, 0, 0, 0, 0, 0, 0}
};


UI_DialogEventDescriptor desc2 [] = {
    105, Event_Select,
    106, Event_Select,
    -1,  Event_None
};




AppWindow::AppWindow ()
: UI_CompositeVObject (NULL, desc, FALSE, UI_Rectangle (50, 50, 500, 400))
{
    msg = new UI_Label (this, UI_Rectangle (10, 100, 340, 250));
    msg->Font().PointSize(10);
    _title = "YACL Dialog Demo";
}




extern FAR UI_ViewDescriptor  DLG_DIALOG_1_Item[];
extern FAR UI_RectangleStruct DLG_DIALOG_1_Shape;


#if defined(__MS_WINDOWS__)
#define END_OF_LINE "\r\n"
#else
#define END_OF_LINE "\n"
#endif


bool AppWindow::HandleChildEvent(UI_Event* e)
{
    if( e->Origin()->ViewID() == 3 && e->Type()== Event_Select) {
        _Application->End();
        return FALSE;
    }
    if (e->Origin()->ViewID() != 2 || e->Type() != Event_Select)
        return FALSE;

    UI_Dialog* d =  new UI_Dialog (this,  DLG_DIALOG_1_Item,
                                   DLG_DIALOG_1_Shape, desc2);
    d->Title() = "Inner dialog";

    CL_String* stred_data = (CL_String*) ((*d) [104]).Model();
    *stred_data = "File.txt";
    CL_String* msg_value = (CL_String*) (msg->Model());
    *msg_value = "";

    // Now execute the dialog modally
    UI_ViewID quitID = d->ExecuteModal ().id; 

    // Retrieve its contents
    CL_IntPtrMapIterator itr (*(CL_IntPtrMap*) (d->Model()) );
    itr.Reset();
    while (itr.More()) {
        CL_IntPtrAssoc  assoc = itr.Next();
        UI_ViewID id = assoc.key;
        *msg_value += "Id " + CL_String (id)
            + " value: " + assoc.value->AsString() + END_OF_LINE;
    }
    *msg_value += "Quit button Id: " + CL_String (quitID)
        + END_OF_LINE;

    // Get rid of the dialog
    _Application->Destroy (d);
    return TRUE;
}

