

#include "ui/ui.h"
#include "ui/interval.h"
#include "appwin.h"
#include "dlgs.h"


UI_ViewDescriptor MainGroup [] = {
{View_ExOrToggleButton, 200, 10,  30,  120, 24, TRUE,  "Cars", NULL},
{View_ExOrToggleButton, 201, 10,  60,  120, 24, TRUE,  "Coffee", NULL},
{View_ExOrToggleButton, 202, 10,  90,  120, 24, TRUE,  "Sandwiches", NULL},
{View_None, 0, 0}                                         
};                                                        
                                                          
UI_ViewDescriptor MainDesc [] = {                         
{View_ButtonGroup    ,  203, 10, 20,  140, 140, FALSE, "Choice",
     MainGroup},
{View_None, 0, 0}
};

extern UI_ViewDescriptor DLG_CarOptions_Item[];
extern UI_ViewDescriptor DLG_Sandwich_Item[];
extern UI_ViewDescriptor DLG_Coffee_Item[];

UI_ViewDescriptor* AllDialogs[] = {
     DLG_CarOptions_Item,
     DLG_Coffee_Item,
     DLG_Sandwich_Item,
     0
};

AppWindow::AppWindow()
: UI_CompositeVObject (NULL, MainDesc, FALSE, UI_Rectangle (50, 50, 650, 300))
{
    _current = NULL;
    for (short i = 0; AllDialogs[i] != 0; i++) {
        _comp[i] = new UI_CompositeVObject
            (this, AllDialogs[i], TRUE, UI_Rectangle (165, 10, 480, 200));
        _comp[i]->MakeInvisible();
    }
    UI_StringView& l = ((UI_StringView&) ((*_comp[2])[ID_FIXINGS_LIST]));
    UI_StringSequence* s = (UI_StringSequence*) l.Model();
    s->Add ("Lettuce");
    s->Add ("Tomatoes");
    s->Add ("Onions");
    s->Add ("Cream cheese");
    s->Add ("Turkey");
    s->Add ("Bacon");
    s->Add ("Ham");
    s->Add ("Tuna");
}

void AppWindow::Initialize ()
{
    UI_CompositeVObject::Initialize(); // Very important!!
    _title = "Dynamic Dialog Demo";
}

void AppWindow::ShowDialog (short index)
{
    if (index < 0 || index > 2)
        return; // Should never happen
    if (_current == _comp[index])
        return; // Same as what's being shown
    if (_current)
        _current->MakeInvisible();
    _current = _comp[index];
    _current->MakeVisible();
}

bool AppWindow::HandleChildEvent (UI_Event* e)
{
    if (e->Type() != Event_Select)
        return FALSE;
    short n = e->Origin()->ViewID();
    if (n >= 200 && n <= 202)
        ShowDialog (n - 200);
    // Take advantage of the fact that view id's of the buttons are
    // consecutive beginning at 200.
    return TRUE;
}



