

// A second "hello, world" program using YACL


#include "ui/ui.h"



// ======================== Class MyComposite ===========================

#define ID_BUTTON 10
#define ID_LABEL  11
UI_ViewDescriptor desc[] = {
    {View_PushButton, ID_BUTTON,  75, 80, 225, 50, TRUE, TRUE, ""},
    {View_Label,      ID_LABEL, 55, 50, 245, 20, FALSE, TRUE,  ""},
    {View_None, 0}
};

class MyComposite: public UI_CompositeVObject {

public:
    MyComposite ();

    // Override the Composite's virtual method:
    bool HandleChildEvent (UI_Event* e);

    bool WantToQuit();
    
protected:
    short count;
};

    
MyComposite::MyComposite()
: UI_CompositeVObject (NULL, desc, FALSE, UI_Rectangle (50, 50, 400, 300)),
  count (5)
{
    ((UI_PushButton&) (*this)[ID_BUTTON]).Title() =
                "Click here " + CL_String(count) + " times.";
}

bool MyComposite::HandleChildEvent (UI_Event* e)
{
    if (e->Origin()->ViewID() == ID_BUTTON &&
        e->Type() == Event_Select) {
        count--;
        if (count == 0) {
            _Application->Destroy (this);
            // Do an _Application->End() if we want conditinal termination
        }
        else {
            CL_String& s (((UI_PushButton&) (*this)[ID_BUTTON]).Title());
            s = "Click here " + CL_String(count) + " times.";
            switch (count) {
            case 4: {
                UI_Font& font (Font());
                font.TypeFace ("MS Sans Serif");
                font.Italic (TRUE);
                break;
            }

            case 2: {
                UI_Font& font (e->Origin()->Font());
                font.TypeFace ("Arial");
                font.Italic (FALSE);
                font.PointSize (14);
                break;
            }
                
            case 1: {
                UI_Font& font ((*this)[ID_LABEL].Font());
                font.TypeFace ("Arial");
                font.Italic (FALSE);
                font.PointSize (11);
                break;
            }
                
            default:
                break;
            }
        }
        return TRUE;
    }
    return FALSE;
}


bool MyComposite::WantToQuit()
{
    return (UI_SimpleDialog ("Do you really want to quit?", UIS_YesNo,
                             UIS_Question, this) == UI_IDYES);
}



// ======================== Main program ===========================


int UI_Application::Main (int /* argc */, char* [])
{
    AppWindow* mainWin = new MyComposite;
    Controller().MakeTopWindow (mainWin);
    (*mainWin)[ID_LABEL].Title() = CL_String ("Hello, world, this is YACL!");
    Run();
    return 0;
}



