

#include "ui/ui.h"

#include "menudrv.h"
#include "box.h"
#include "ids.h"

#ifdef __BORLANDC__
extern unsigned _stklen = 35000;
#endif

UI_MenuItemDescriptor App1Submenu [] = {
  {"A one",     NULL,  ID_SUBMENU1, UI_MenuItem::Enabled}
, {"A two",     NULL,  ID_SUBMENU2, UI_MenuItem::Enabled}
, {NULL,        NULL,            0, UI_MenuItem::Enabled}
};

UI_MenuItemDescriptor App1Menu [] = {
  {"&Start",    NULL,  ID_START, UI_MenuItem::Enabled}
, {"S&top",     NULL,  ID_STOP,  UI_MenuItem::Enabled}
, {"Submenu",  App1Submenu, 120, UI_MenuItem::Enabled}
, {"---",       NULL,  NULL,     UI_MenuItem::Enabled} // Separator
, {"&Open...",  NULL,  ID_OPEN,  UI_MenuItem::Enabled}
, {"&Quit",     NULL,  ID_QUIT,  UI_MenuItem::Enabled}
, {NULL,        NULL,     0,     UI_MenuItem::Enabled}
};

UI_MenuItemDescriptor App3Menu [] = {
    {"Start",  NULL,  ID_START2, UI_MenuItem::Enabled}
  , {"Stop",   NULL,  ID_STOP2,  UI_MenuItem::Enabled}
  , {"Quit",   NULL,  ID_QUIT2,  UI_MenuItem::Enabled}
  , {0,        NULL,      0,     UI_MenuItem::Enabled}
};


UI_MenuItemDescriptor MainMenuDesc [] = {
    {"&One",   App1Menu, ID_APP1, UI_MenuItem::Enabled}
  , {"&Two",   NULL,     ID_APP2, UI_MenuItem::Enabled}
  , {"Th&ree", App3Menu, ID_APP3, UI_MenuItem::Enabled}
  , {NULL,     NULL,           0, UI_MenuItem::Enabled}
};


UI_MenuBar*     MainMenu;



typedef CL_Binding<MenuDriver> MenuBinding;




// ======================== Main program ===========================


int UI_Application::Main (int, char* [])
{
    UI_CompositeVObject* root = new UI_CompositeVObject
        (NULL, NULL, FALSE, UI_Rectangle (100, 100, 470, 450));
    Controller().MakeTopWindow (root);
    MainMenu = new UI_MenuBar (MainMenuDesc);
    root->UseMenuBar (MainMenu);

    MenuDriver driver;
    driver.Setup (MainMenu);
    Run();
    return 0;
}

