


#include "appwin.h"

#define ID_BAR    10
#define ID_LABEL  11
#define ID_BTN    12

typedef CL_Binding<AppWindow> Bind;

#if defined(__GNUC__)
template class CL_Binding<AppWindow>;
#endif


AppWindow::AppWindow()
: UI_CompositeVObject (NULL, NULL, FALSE, UI_Rectangle (100, 100, 200, 260))
{
    _btn   = new UI_ToggleButton (this, UI_Rectangle (10, 10, 150, 20),
                                  ID_BTN);
    _msg   = new UI_Label (this, UI_Rectangle (30, 90, 80, 20), ID_LABEL);
    _bar   = new UI_VScrollBar (this, UI_Rectangle (150, 35, 30, 180), ID_BAR);
    _bar->Range() = CL_Interval (0, 255);
    Bind bind (this, (Bind::MethodPtr) &AppWindow::_DoScroll);
    _bar->ClientSet().Add (bind, 1);
    CL_Interval init (26, 100); // Initial setting
    *(CL_Interval*) (_bar->Model()) = init;
    *(CL_String*)(_msg->Model()) = init.AsString();
    _btn->Title() = "Smooth scroll";
    *(_btn->Model()) = CL_Integer ((short) TRUE);
}

bool AppWindow::_DoScroll (CL_Object&, long)
{
    CL_String& s = *(CL_String*) _msg->Model();
    s = _bar->Model()->AsString();
    _Controller->GiveFocusTo (*_bar);
    return TRUE;
}


bool AppWindow::HandleChildEvent (UI_Event* e)
{
    if (e->Origin()->ViewID() !=  ID_BTN)
        return FALSE;
    CL_Integer& v = *(CL_Integer*) (e->Origin()->Model());
    _bar->SmoothScroll() = v.Value();
    return TRUE;
}
